﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private myActivity As Activity
	Private myObject As Object
	Private myPanel As Panel
	Private myLeft, myTop, myWidth ,myHeight As Int
	Private myStrokeLenght As Int
	Private myStrokeWidth As Int
	Private myStrokeColor, myClearColor As Int
	Private myValue As Int
	Private myBundles, myBundleWidth As Int
	Private mySideBySide As Int
	Private myPosLeft, myPosTop As Int
	Private cvs As Canvas
	Private Timer1 As Timer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ThisActivity As Activity, Module As Object, CustomPanel As Panel, StrokeColor As Int, ClearColor As Int)
	
		
		myActivity 	  = ThisActivity
		myObject	  = Module
		myPanel       = CustomPanel
		myWidth		  = CustomPanel.Width
		myHeight	  = CustomPanel.Height
		myStrokeLenght= 20dip
		myStrokeWidth = 2dip
		myStrokeColor = StrokeColor
		myClearColor  = ClearColor
		myPosLeft	  = 2dip
		myPosTop	  = 0dip				
		cvs.Initialize(myPanel)
				
End Sub

Private Sub CalcBundles As Int
	Dim HelpDouble As Double
	Dim HelpInt As Int
	HelpDouble = Round2(myValue/5,0)
	HelpInt = HelpDouble
	Return HelpInt
End Sub

Private Sub CalcBundleWidth As Int
	Return 11 * myStrokeWidth ' Marginal + (myStrokeWidth + Blanc * 4) + Marginal + (Marginal between Bundles)
End Sub

Private Sub CalcSideBySide As Int
	Dim HelpString As String
	Dim HelpDouble As Double
	Dim HelpInt As Int
	HelpDouble = (myWidth - myPosLeft)/myBundleWidth
	HelpString = HelpDouble
	If HelpString.IndexOf(".") > -1 Then
		HelpString = HelpString.SubString2(0, HelpString.IndexOf("."))
	End If
	HelpInt = HelpString
	Return HelpInt
End Sub

Public Sub setStrokeLenght(Value As Int) 
	myStrokeLenght = Value
End Sub

Public Sub setStrokeWidth(Value As Int)
	myStrokeWidth = Value
End Sub

Public Sub setStrokeColor(Value As Int)
	myStrokeColor = Value
End Sub

Public Sub setStrokeLeft(Value As Int)
	myPosLeft = Value
End Sub

Public Sub setStrokeTop(Value As Int)
	myPosTop = Value
End Sub
	

Public Sub setPanelLeft(Value As Int)
	myLeft	  	 = Value
	myPanel.Left = Value
End Sub

Public Sub setPanelTop(Value As Int)
	myTop 	 	 = Value 
	myPanel.Top	 = Value
End Sub
	
Public Sub setPanelWidth(Value As Int)
	myWidth 	  = Value
	myPanel.Width = Value
End Sub

Public Sub setPanelHeight(Value As Int)
	myHeight 	   = Value 
	myPanel.Height = Value
End Sub
	
Public Sub setSideBySide(Value As Int)
	mySideBySide = Value
End Sub

Public Sub setClearColor(Value As Int)
	myClearColor = Value
End Sub

Public Sub Clear
	Dim myRec As Rect
	myRec.Initialize(0,0,myWidth,myHeight)
	cvs.DrawRect(myRec,myClearColor, True, 2dip)
	myPanel.Invalidate
End Sub

Public Sub Show(Value As Int)
	Dim Row, SW, PosLeft, PosTop, iCounter As Int
	Clear ' Delete Canvas
	cvs.Initialize(myPanel)
	myValue		  = Value
	myBundles     = CalcBundles
	myBundleWidth = CalcBundleWidth
	mySideBySide  = CalcSideBySide
	
	PosLeft = myPosLeft + myStrokeWidth
	PosTop  = myPosTop
	Value 	= myValue
	Row   	= 1
	SW		= myPosTop
	
	For i = Value To 0 Step -1  
		If Value >= 5 Then		
			Value = Value - 5
			PaintBundle(5, PosLeft, PosTop)	
			i = i - 4
			iCounter = iCounter + 1
			'Log("iCounter / mySideBySide = " & iCounter & "/" & mySideBySide)
			If iCounter = mySideBySide Then 
				iCounter = 0
				PosTop 	 = Row * (SW + myStrokeLenght) + SW
				Row 	 = Row + 1
				PosLeft  = myPosLeft + myStrokeWidth			
			Else
				PosLeft = PosLeft + myBundleWidth + myStrokeWidth
			End If			
		Else
			PaintBundle(i, PosLeft, PosTop)
		End If
	Next
	myPanel.Invalidate
End Sub
Private Sub PaintBundle(Value As Int, PosLeft As Int, PosTop As Int)
	If Value = 0 Then 
		Return
	End If
	If Value > 5 Then
		ToastMessageShow("Value is over 5",True)
		Return
	End If
	Dim SW As Int
	SW = myStrokeWidth
	For i = 1 To Value
		If i = 5 Then
			cvs.DrawLine( PosLeft - SW , PosTop, PosLeft + (SW*2*i), PosTop +  myStrokeLenght, myStrokeColor, myStrokeWidth)
		Else
			cvs.DrawLine( PosLeft + (SW*2*i) , PosTop, PosLeft + (SW*2*i), PosTop +  myStrokeLenght, myStrokeColor, myStrokeWidth)
		End If
	Next	
End Sub